////////////////////////////////////////////////////////////////
//
// Copyright (C) 2005 Affymetrix, Inc.
//
// This program is free software; you can redistribute it and/or modify 
// it under the terms of the GNU General Public License (version 2) as 
// published by the Free Software Foundation.
// 
// This program is distributed in the hope that it will be useful, 
// but WITHOUT ANY WARRANTY; without even the implied warranty of 
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License 
// along with this program;if not, write to the 
// 
// Free Software Foundation, Inc., 
// 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
//
////////////////////////////////////////////////////////////////

#include <DotProgress.h>
#include <string>
#include <cppunit/extensions/HelperMacros.h>
#include <cppunit/CompilerOutputter.h>
#include <cppunit/extensions/TestFactoryRegistry.h>
#include <cppunit/ui/text/TestRunner.h>

using namespace std;

/**
 * @class DotProgressTest
 * @brief cppunit class for testing conversion functions.
 */
class DotProgressTest : public CppUnit::TestFixture {
  CPPUNIT_TEST_SUITE( DotProgressTest );
  CPPUNIT_TEST( testdot );
  CPPUNIT_TEST( testnodots );
  CPPUNIT_TEST_SUITE_END();

public:
  /** Test reading rows. */
  void testdot();
  void testnodots();
  void setUp();
};

void DotProgressTest::setUp() {
}

void DotProgressTest::testnodots()
{
	std::stringstream str;
	DotProgress dot(&str);
	dot.SetStepProperties(1, 10, 10);
	for (int i=0; i<100; i++)
		dot.Step(2);
	string s=str.str();
	CPPUNIT_ASSERT(s.length() == 0);
}

void DotProgressTest::testdot()
{
	std::stringstream str;
	DotProgress dot(&str);
	dot.SetStepProperties(1, 10, 10);
	for (int i=0; i<100; i++)
		dot.Step(1);
	string s=str.str();
	CPPUNIT_ASSERT(s.length() == 10);
	CPPUNIT_ASSERT(s == "..........");
}


// Registers the fixture into the 'registry'
CPPUNIT_TEST_SUITE_REGISTRATION( DotProgressTest );
